--- old/usr/src/tools/smatch/src/check_precedence.c	Mon Aug  5 08:38:03 2019
+++ new/usr/src/tools/smatch/src/check_precedence.c	Mon Aug  5 08:38:03 2019
@@ -120,6 +120,16 @@
 	sm_warning("shift has higher precedence than mask");
 }
 
+static void match_mask_compare(struct expression *expr)
+{
+	if (expr->op != '&')
+		return;
+	if (expr->right->type != EXPR_COMPARE)
+		return;
+
+	sm_warning("compare has higher precedence than mask");
+}
+
 static void match_subtract_shift(struct expression *expr)
 {
 	if (expr->op != SPECIAL_LEFTSHIFT)
@@ -138,5 +148,6 @@
 	add_hook(&match_condition, CONDITION_HOOK);
 	add_hook(&match_binop, BINOP_HOOK);
 	add_hook(&match_mask, BINOP_HOOK);
+	add_hook(&match_mask_compare, BINOP_HOOK);
 	add_hook(&match_subtract_shift, BINOP_HOOK);
 }
